import * as MongoDB from "mongodb"; // Node.JS MongoDB driver...
// Database within MongoDB Atlas:
const Database_URI = "mongodb+srv://FB:Sauvagnon64@web-scraping.98xi5.mongodb.net/";

const Client = new MongoDB.MongoClient(Database_URI, {
        serverApi: {
            version: MongoDB.ServerApiVersion.v1,
            strict: true,
            deprecationErrors: true,
        }
    }
);

async function Connect() {
    try {
        // Connect client to database:
        await Client.connect();
        // @ts-ignore ('s' field isn't accessible, but:
        console.log("'Client.s.url': " + Client.s.url);
        // Send ping to confirm successful connection:
        await Client.db("admin").command({ping: 1});
        console.log("Pinged... Successfully connected to MongoDB...");
    } finally {
        // Ensures that client closes:
        await Client.close();
    }
}

// Connect().catch(console.dir);

async function Connect_() {
    try {
        await Client.connect();
        const Web_scraping = Client.db("Web_scraping");
        const result = await Web_scraping.admin().listDatabases();
        console.log("Databases: " + JSON.stringify(result.databases));
        const my_data = Web_scraping.collection("data");
        my_data.insertOne({forname: "Franck", surname: "Barbier"}).then(() => {
            my_data.countDocuments({}).then(value => {
                console.log("\n'my_data.countDocuments({})': " + value); // '1'
                my_data.drop().then(() => {
                    Client.close().then(() => {
                        console.log("\nSee you later!");
                    });
                });
            });
        });
    } catch (error: unknown) {
        console.log(`Problem? ${error}`);
        await Client.close();
    }
}

Connect_();
